// Parsoa Khorsand 1395/1/13

#include "sm.h"

#include "interface.h"
#include "frame.h"
#include "math.h"

using namespace std;

// ========================================================================== //
// ========================================================================== //
// ========================================================================== //

SimulatedMachine::SimulatedMachine (const ClientFramework *cf, int count) :
	Machine (cf, count) {
}

SimulatedMachine::~SimulatedMachine () {

}

void SimulatedMachine::initialize () {
	//initialize containers
	//calculate your index
	this->index = 0;
}

void SimulatedMachine::run () {
}

void SimulatedMachine::parseArguments (int argc, char *argv[]) {
}

// ========================================================================== //
// ========================================================================== //
// ========================================================================== //

void SimulatedMachine::processFrame (Frame frame, int interface) {
}

// ========================================================================== //
// ========================================================================== //
// ========================================================================== //

int SimulatedMachine::generatePrime(int k, int e, bool odd) {
	int begin = 1 << (k - 1) ; // k bits
	int end = 1 << k ; // k + 1 bits
	cerr << "generating prime number in the range [" << begin << "," << end - 1 << "]" << endl ;
	int n = 0 ; 
	for (int i = begin ; i < end ; i++) {
		//cerr << "testing " << i << endl ;
		if (isPrime(i) && i % e != 1) {
			n ++ ;
			if (odd) {
				if (n == this->index) {
					return i ;
				}
			} else {
				if (n == 5 - this->index) {
					return i ;
				}
			}
		}
	}
	return -1 ;
}

bool SimulatedMachine::isPrime(int a) {
	//cerr << "testing primality for " << a << endl ;
	for(int j = 2 ; j < a ; j++) {
		if(a % j == 0) {
			//cerr << "not prime" << endl ;
			return false ;
		}
	}
	//cerr << "prime" << endl ;
	return true ; 
}

int SimulatedMachine::modularInverse(int u, int v) {
	cerr << "calculating modular inverse" << endl ;
	unsigned int inv, u1, u3, v1, v3, t1, t3, q;
    int iter;
    /* Step X1. Initialise */
    u1 = 1;
    u3 = u;
    v1 = 0;
    v3 = v;
    /* Remember odd/even iterations */
    iter = 1;
    /* Step X2. Loop while v3 != 0 */
    while (v3 != 0)
    {
        /* Step X3. Divide and "Subtract" */
        q = u3 / v3;
        t3 = u3 % v3;
        t1 = u1 + q * v1;
        /* Swap */
        u1 = v1; v1 = t1; u3 = v3; v3 = t3;
        iter = -iter;
    }
    /* Make sure u3 = gcd(u,v) == 1 */
    if (u3 != 1)
        return 0;   /* Error: No inverse exists */
    /* Ensure a positive result */
    if (iter < 0)
        inv = v - u1;
    else
        inv = u1;
    cerr << (u * inv) % v << endl ;
    return inv;
}

// ========================================================================== //
// ========================================================================== //
// ========================================================================== //
