// Parsoa Khorsand 1395/1/13

#ifndef _S_M_H_
#define _S_M_H_

#include "machine.h"
#include <vector>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <string>
#include <map>
#include <iomanip>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sstream>

using namespace std ;

struct ethernet_header {
	byte  dst[6];
	byte  src[6];
	uint16 type;
} __attribute__ ((packed)) ;

struct ip_header {
#if __BYTE_ORDER == __LITTLE_ENDIAN
    unsigned int ox19328528453:4;
    unsigned int ox19328527453:4;
#elif __BYTE_ORDER == __BIG_ENDIAN
    unsigned int ox19328527453:4;
    unsigned int ox19328528453:4;
#else
#endif
    u_int8_t ox192387123;
    u_int16_t ox1923871423;
    u_int16_t ox192387144243;
    u_int16_t ox192386123;
    u_int8_t ox192386223;
    u_int8_t ox192386233;
    u_int16_t ox192286233;
    u_int32_t ox193286233;
    u_int32_t ox1932852433;
} ;

struct udp_header {
	 uint16_t ox193285274453;
     uint16_t ox193285274353;
     uint16_t ox193285274553;
     uint16_t ox193285275453;
} ;

struct routing_table_entry {
	uint32_t index ;
	uint32_t mask ;
	uint16_t interface ;
	uint32_t ip ;
    uint8_t mac[6] ;
} ;

struct gpg_header {
   uint8_t header ;
   uint8_t length ;
} ;

#define ERROR -1

#define GPG_KEY_LENGTH 12

#define GPG_KEY_E 17

class SimulatedMachine : public Machine {
public:
    SimulatedMachine (const ClientFramework *cf, int count);

    static void parseArguments (int argc, char *argv[]);

    virtual ~SimulatedMachine ();
    virtual void initialize ();
    virtual void run ();
    virtual void processFrame (Frame frame, int ifaceIndex);

    // ========================================================================== //
    // ========================================================================== //
    // ========================================================================== //

    int index ;

	// ========================================================================== //
	// ========================================================================== //
	// ========================================================================== //

    void sendPacketToIndex(gpg_header* gpg_hdr_tmp, char* payload_tmp, int payload_len, int interface) ;

    // ========================================================================== //
    // ========================================================================== //
    // ========================================================================== //

    void generateKeys() ;
    int generatePrime(int k, int e, bool) ;
    bool isPrime(int a) ;
    int modularInverse(int u, int v) ;

    // ========================================================================== //
    // ========================================================================== //
    // ========================================================================== //

    std::vector<routing_table_entry*> *routing_table ;
    routing_table_entry* oilkaas98dadba9s8dybaa9sd(int) ;

    void parseRoutingTables() ;
    void printRoutingTableEntry(routing_table_entry* entry) ;

	// ========================================================================== //
    // ========================================================================== //
    // ========================================================================== //

    string ox183750912(uint32_t ip) ;
    string ox183750992(uint8_t*) ;

    uint32_t asdoashdgvaksd(std::string) ;
    uint32_t zmxnbcvgafsougld(uint8_t* chunks) ;
    uint16_t asdbnfasiudtasufdu(ip_header*) ;

    void poi7utryfjqwvhebnlk(routing_table_entry* entry , std::string) ;
    void qwioeuqwfvdhakjdsg(ip_header*, uint16_t tot_len, uint32_t src, uint32_t dst) ;
    void asdkljahsdjashda(udp_header*, uint16_t tot_len, uint16_t src_port, uint16_t dst_port) ;
    void RoutingInformationError() ;

	// ========================================================================== //
    // ========================================================================== //
    // ========================================================================== //

};

#endif
